CoCoALib - Feature #780

GroebnerFan/ExternalLib-GFan: improve package
24 Sep 2015 18:16 - Anna Maria Bigatti

Status: In Progress Start date: 24 Sep 2015

Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 20%

Category: Improving Estimated time: 20.00 hours

Target version: CoCoALib-1.0 Spent time: 6.00 hours

Description

First prototype is working.

Investigate and improve it, and implement it in cocoalib.

Related issues:

Related to CoCoALib - Feature #762: ExternalLib-GFan: first prototype Closed 28 Aug 2015
Related to CoCoA-5 - Feature #903: New function CallOnGroebnerFanldeals: call... Closed 04 Jul 2016

Related to CoCoALib - Slug #1049: GroebnerFan: slow examples

In Progress 19 Apr 2017

History

#1 - 24 Sep 2015 18:22 - Anna Maria Bigatti
- Status changed from New to In Progress

- % Done changed from 0 to 20

In the package there are lots of operations on integers and those would surely be faster in cocoalib (at some point).

But | did make some improvements:
- the function "matrix" in cocoa-5, using the function SetRow (and that's good in general ;-)
- a minor improvement in MarkedPolynomialsTolnequalities (just to touch fewer INTs)

- in GroebnerBasisFlip: ideal(apply(f, gens(l))) instead of ideal(apply(f, GBasis(l))) (the ideals are equal, and gens are generally simpler and fewer)

With these changes | get the answer in 68s instad of 82s.
(That's a decent start)

/**/ Use R ::= QQla,b,cl;
/**/ I := ideal (a"5+b"3+c”*2-1, b”*2+a"2+c-1, c”3+a"~6+b”*5-1);
/**/ 1l:=AllReducedGroebnerBases (I); len(l);

What | find strange is that | get these two cumulative times:
GFanGetFacets: 21.999sec

GFanRelativelnteriorPoint: 4.599sec

and these alone take much longer than the complete computation in gfan.
Can the overhead be so bad?
#2 - 16 Feb 2016 18:04 - Anna Maria Bigatti
- Target version changed from CoCoALib-0.99540 Feb 2016 to CoCoALib-0.99542 spring 2016

#3 - 22 Mar 2016 18:00 - Anna Maria Bigatti
- Target version changed from CoCoALib-0.99542 spring 2016 to CoCoALib-1.0

#4 - 04 Jul 2016 11:44 - Anna Maria Bigatti

- Related to Feature #903: New function CallOnGroebnerFanldeals: call function on GFan ideals added

#5 - 19 Apr 2017 18:44 - Anna Maria Bigatti
- Related to Slug #1049: GroebnerFan: slow examples added

#6 - 20 Apr 2017 10:02 - Anna Maria Bigatti
Abbott found this gives error (#1049)

GroebnerFanIdeals (ideal (x*y,y"3+x,vy"3));

| investigated: it's an error in ReducedGBasis (argh)

#7 - 21 Apr 2017 11:06 - Anna Maria Bigatti

- Subject changed from ExternalLib-GFan: improve package to GroebnerFan/ExternallLib-GFan: improve package
